//----------------------------------------------------------
// This is an asvanced example which also defines your own
// labeling for coefficients and dimensions. Furthermore
// plots are generated and values wiht the calculated poly-
// nome are ploted. But the data is only one dimensional
//----------------------------------------------------------

// Restart programme
clear;    // Clear memory
clc;      // Clear display
clf;      // Clear plot
exec('Functions.sci'); //Get functions from extern file

// Enter measured data: Main input section
data =[      // Define dataset
1;2;3;3.5;4;5;6];

zval =[      // Define values according to dataset
9;2;3;4.5;6;5;4];

// Input the polynome
polynome =[
0 1 -1 2
];

// Enter names for coefficients and dimensions
dimNames   = ["x"];   // Label of dimensions
coeffNames = ["a" "b" "c" "d" "e" "f" "g"];   // Names of dimensions

// Generate automatic names if missing
[cx cy] = size(coeffNames);
for i=1:length(polynome(1,:))
  if (i>cy)
    coeffNames(1,i) = "a" + string(i);
  end
end
clear cx, cy;

// Printout polynome formula in pretty shape
PrettyPrintF(polynome, [], []);                // Print with auto names
PrettyPrintF(polynome, coeffNames, dimNames);  // Print with own names

// Printout results (main calculation)
printf("Result:\n-------\n");
y = PowerFit(data,zval,polynome);  // Calc polynome (main function)
[cx cy] = size(y);
disp([coeffNames(1:cx)' string(y)]);     // Printout coefficients
clear cx, cy;

// Generate nice plots
plot(data,zval,"or");               // Plot entered data
D = (max(data)-min(data))*1.05/2;
C = (min(data)+max(data))/2;
xx = C-D:0.1:C+D;                  // Generate x area
for i=1:length(xx)                 // Calculate corresponding values
  yy(i) = sum((xx(i).^polynome).*(y'));
end
plot(xx,yy)                        // Plot regression polynome